;;; -*-emacs-lisp-*-

(skel-include "skelrc.c")

(defun skelrc-c-guard-name ()
  (if buffer-file-name
      (upcase (file-name-sans-extension (file-name-nondirectory
					 buffer-file-name)))
    (skel-lookup 'include-guard-name)))

(setq skel-alist
      (append
       '((preamble . "[[guard]][[c++-guard]][[includes]][[structures]][[functions]]")
	 (guard . "#ifndef [[guard-name]]_H\n#define [[guard-name]]_H\n\n")
	 (guard-name . (skelrc-c-guard-name))
	 (c++-guard . "#ifdef __cplusplus\n  extern \"C\" {\n#endif\n\n")
	 (includes . "[[includes-banner]]\n\n[[headers]]")
	 (includes-banner . (skelrc-banner "Header files"))
	 (headers . "")
	 (structures . "[[struct-banner]]\n\n")
	 (struct-banner . (skelrc-banner "Data structures"))
	 (functions . "[[func-banner]]\n\n")
	 (func-banner . (skelrc-banner "Functions provided"))
	 (postamble . "\n\n[[c++-unguard]]#endif")
	 (c++-unguard . "#ifdef __cplusplus\n  }\n#endif\n\n"))
       skel-alist))
